力扣每日一题41:缺失的第一个正数

题目描述:

给你一个未排序的整数数组 nums ,请你找出其中没有出现的最小的正整数。

请你实现时间复杂度为 O(n) 并且只使用常数级别额外空间的解决方案。

示例 1:

复制代码
输入:nums = [1,2,0]
输出:3

示例 2:

复制代码
输入:nums = [3,4,-1,1]
输出:2

示例 3:

复制代码
输入:nums = [7,8,9,11,12]
输出:1

提示:

  • 1 <= nums.length <= 5 * 105
  • -231 <= nums[i] <= 231 - 1

通过次数

325.7K

提交次数

749K

通过率

43.5%

思路和题解:

设数组长度为n,则确实的第一个正数只能在1,n+1的闭区间

思路一:暴力搜索。时间O(n^2),空间O(1),不符合要求

依次判断1,n在不在数组里,如果不在就返回那个不在的数,如果都在就返回n+1。代码。

复制代码
//暴力循环
class Solution {
public:
    int firstMissingPositive(vector<int>& nums) {
        int n=nums.size();
        for(int i=1;i<=n;i++)
        {
            bool flag=false;
            for(int j=0;j<n;j++)
            {
                if(nums[j]==i)
                {flag=true;break;}
            }
            if(!flag) return i;
        }
        return n+1;
    }
};

思路二:普通的哈希表。时间O(n),空间O(n),不符合要求。

用一个长度为n的数组来标记1,n有没有出现过。

复制代码
//普通哈希表
class Solution {
public:
    int firstMissingPositive(vector<int>& nums) {
        int n=nums.size();
        vector<bool> hash(n,false);
        for(int i=0;i<n;i++)
        {//出现了就标记为真
            if(nums[i]>0&&nums[i]<=n)
            hash[nums[i]-1]=true;
        }
        for(int i=0;i<n;i++)
        {
            if(hash[i]==false) return i+1;
        }
        return n+1;
    }
};

思路三:原地哈希表。时间O(n),空间O(1)

思路二是我们能想到的比较好的办法了,但是空间复杂度还是不能达到要求,那我们怎么来优化这个空间复杂度O(n)呢?要知道,只用O(n)的时间复杂度,也就是只用一层的循环,要找出缺失的第一个正数的话,不用其他空间来存储正数存在的状态时不可能的。既然必须要用空间来存储一些状态,又只能额外使用常数的空间,那我们只好拿给定的数组nums作为存储状态的空间。也就是说用原数组nums作为哈希表。

问题是怎么标记一个正数是否出现的状态。对于num<=0&&num>n的数,num在1,n之外无论怎么变化,都不会改变答案。那就干脆先把数组里所有<=0的数先变成n+1,之后再遍历数组,把每个1,n内的数num对应下标处都改为负数。最后再遍历一遍数组,对应元素不为负就说明这个数对应的位置是第一个缺失的正数。

复制代码
class Solution {
public:
    int firstMissingPositive(vector<int>& nums) {//原地哈希表
    //第一个缺失的数只能出现在[1,n+1]的闭区间里
        int n=nums.size();
        for(int i=0;i<n;i++)
        {//若出现负数或零或大于n的数,那第一个确实的数就在[1,n]
            if(nums[i]<=0) nums[i]=n+1;
        }
        for(int i=0;i<n;i++)
        {//将[num-1]标记为负,表示正数num没有缺失,num>n时不用管
            int num=abs(nums[i]);
            if(num<=n)
            {
                nums[num-1]=-abs(nums[num-1]);
            }
        }
        for(int i=0;i<n;i++)
        {
            if(nums[i]>0) return i+1;
        }
        return n+1;
    }
};
相关推荐
CCblandy3 小时前
向量检索 ANN 参数实测:换一种数据分布,recall 掉了 51 个百分点
人工智能·python·算法·自然语言处理·性能优化
CS创新实验室3 小时前
一棵树怎么做到“自平衡还不太费力“?——红黑树的旋转与染色
数据结构·算法·红黑树·408·计算机考研
Logic1013 小时前
C语言/数据结构位运算题解:异或XOR找出被挑选一次的果子编号——只出现一次的数字
c语言·数据结构·算法·数组·位运算·时间复杂度·空间复杂度
深圳市快瞳科技有限公司3 小时前
面向端侧部署的多帧宠物身份识别:完整性评分机制与工程约束
人工智能·算法·计算机视觉·端侧ai·宠物识别·宠物ai·宠物身份识别
从小白到软工5 小时前
4-3 项目-学生成绩管理系统(上)
c语言·开发语言·数据结构·经验分享·ai编程
悠仁さん5 小时前
非类型模板参数的特化与偏特化
java·数据结构·算法
垆边人似月.5 小时前
最优河堤加固(二分答案 + 前缀和)
算法
171320330计算机毕设编程6 小时前
计算机毕业设计 基于Hadoop的新能源汽车发展前景分析 LW PPT
java·大数据·hadoop·python·算法·随机森林·线性回归
haluhalu.6 小时前
深入理解 AI Agent(1.2):Harness 工程——模型之外的竞争力
前端·数据结构·人工智能·python·langchain·个人开发
垆边人似月.6 小时前
幻兽防御战(贪心算法)
数据结构·算法